/**********************************************************************
  }V̊蓖ăR}h
  $Id: memal_cmd.c,v 1.4 2002/11/03 03:57:35 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

int	memal_cmd( struct TOKEN_STRUCT *tk_pt, int mode )
{
  int   i ;
  int   seg ; 
  int   id ;
  int   res ;
  unsigned char *atrname[]={ "normal", "shared" } ;
  
  id=proc_list.cur_id ;
  
  if( tk_pt->pt[1]==NULL ){
    SYSMSG("---- Memory map of PID %d ---\n",id) ;
    for( i=0 ; i<MEM_SEGMENT_NUM ; i++ ){
      if( proc_list.proc[id].mem[i]!=NULL ){
	SYSMSG("%02x000000 : size=%08x , %s\n",
	       i,proc_list.proc[id].mem_size[i],
	       atrname[proc_list.proc[id].mem_attr[i]]) ;
      }else{
	//SYSMSG("%02x000000 : no allocate\n",i) ;
      }
    }
    return(NORMAL_EXIT) ;
  }
  
  if( tk_pt->pt[2]==NULL ) seg=0 ;
  else                     seg=exatoi(tk_pt->pt[2]) ;
  if( seg<0 || seg>=MEM_SEGMENT_NUM ) {
    SYSMSG("Specified invalid segment(seg=0x%x)\n", seg ) ;
    return(SPECIFY_ERROR) ;
  }
  
  i=exatoi(tk_pt->pt[1]) ;
  if( i>0 ){
    res=memal( &proc_list.proc[id], seg, i, MEM_ATTR_NORMAL ) ;
    if(       res==MEM_ALLOC_ERROR ){
      SYSMSG("Can not allocate memory(size=%d)\n", i ) ;
    }
    return( res ) ;
  }else{
    SYSMSG("Specified invalid memory size(size=%d range:1`)\n",i ) ;
    return(SPECIFY_ERROR) ;
  }
  
  return(NORMAL_EXIT) ;

}
/*********************************************************************
  
  PCIAhXԂ\邽߁A256MB̃ZOgɃAhXԂ
  BVXeRg[̗pȂǂɍ킹āAKvȃANZX
  Ԃ蓖ĂB
  
  020622
  ZOgTCY256MBł̓TCY傫߂MPC106̃}bsO
  0xff______犄ROMԂ̊蓖ĂłȂ߁AZOg
  TCY16MB܂ŏk(ZOg=256)B
  ܂A蓖Ăsp֐memal():memal.cpӂA
  gpă蓖ĂslɎdlύXB
*********************************************************************/
